import 'dart:io';

import 'package:yourappname/model/generalsettingmodel.dart';
import 'package:yourappname/model/loginregistermodel.dart';
import 'package:yourappname/model/pagesmodel.dart';
import 'package:yourappname/model/successmodel.dart';
import 'package:yourappname/utils/adhelper.dart';
import 'package:yourappname/utils/sharedpre.dart';
import 'package:yourappname/utils/utils.dart';
import 'package:yourappname/webservice/apiservices.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

class GeneralProvider extends ChangeNotifier {
  GeneralSettingModel generalSettingModel = GeneralSettingModel();
  PagesModel pagesModel = PagesModel();
  LoginRegisterModel loginSocialModel = LoginRegisterModel();
  LoginRegisterModel loginOTPModel = LoginRegisterModel();
  LoginRegisterModel loginTVModel = LoginRegisterModel();
  SuccessModel logoutmodel = SuccessModel();

  bool loading = false;
  String? appDescription;

  SharedPre sharedPre = SharedPre();

  Future<void> getGeneralsetting(BuildContext context) async {
    loading = true;
    generalSettingModel = await ApiService().genaralSetting();
    printLog('generalSettingData status ==> ${generalSettingModel.status}');
    if (generalSettingModel.status == 200) {
      if (generalSettingModel.result != null) {
        for (var i = 0; i < (generalSettingModel.result?.length ?? 0); i++) {
          await sharedPre.save(
            generalSettingModel.result?[i].key.toString() ?? "",
            generalSettingModel.result?[i].value.toString() ?? "",
          );
          printLog(
              '${generalSettingModel.result?[i].key.toString()} ==> ${generalSettingModel.result?[i].value.toString()}');
        }

        appDescription = await sharedPre.read("app_desripation") ?? "";
        printLog("appDescription ===========> $appDescription");
        /* Get Ads Init */
        if (context.mounted && !kIsWeb) {
          AdHelper.getAds(context);
        }
      }
    }
    loading = false;
    notifyListeners();
  }

  Future<void> getPages() async {
    loading = true;
    pagesModel = await ApiService().getPages();
    printLog("getPages status :==> ${pagesModel.status}");
    loading = false;
    notifyListeners();
  }

  Future<void> getsignout() async {
    loading = true;
    logoutmodel = await ApiService().logout();
    printLog("getlogoutmodelPages status :==> ${logoutmodel.status}");
    loading = false;
    notifyListeners();
  }

  Future<void> loginWithSocial(
      email, name, type, deviceType, File? profileImg) async {
    printLog("loginWithSocial email :==> $email");
    printLog("loginWithSocial name :==> $name");
    printLog("loginWithSocial type :==> $type");
    printLog("loginWithSocial profileImg :==> ${profileImg?.path}");

    loading = true;
    loginSocialModel = await ApiService().loginWithSocial(
      email,
      name,
      type,
      deviceType,
      profileImg,
    );
    printLog("loginWithSocial status :==> ${loginSocialModel.status}");
    printLog("loginWithSocial message :==> ${loginSocialModel.message}");
    loading = false;
    notifyListeners();
  }

  Future<void> loginWithOTP(mobile) async {
    printLog("getLoginOTP mobile :==> $mobile");

    loading = true;
    loginOTPModel = await ApiService().loginWithOTP(mobile);
    printLog("login status :==> ${loginOTPModel.status}");
    printLog("login message :==> ${loginOTPModel.message}");
    loading = false;
    notifyListeners();
  }
}
