import 'dart:developer';
import 'dart:io';
import 'package:carousel_slider/carousel_slider.dart';
import 'package:yourappname/pages/bottombar.dart';
import 'package:yourappname/pages/musicdetails.dart';
import 'package:yourappname/provider/downloadprovider.dart';
import 'package:yourappname/provider/profileprovider.dart';
import 'package:yourappname/utils/utils.dart';
import 'package:yourappname/widget/musicutils.dart';
import 'package:flutter/material.dart';
import 'package:just_audio/just_audio.dart';
import 'package:progress_dialog_null_safe/progress_dialog_null_safe.dart';
import 'package:provider/provider.dart';
// import 'package:provider/provider.dart';

class MusicManager {
  late ConcatenatingAudioSource playlist;
  dynamic episodeDataList;
  BuildContext context;

  MusicManager(this.context);
  CarouselController pageController = CarouselController();
  late ProgressDialog prDialog = ProgressDialog(context);
  late ProfileProvider profileProvider;

/* Music */
  void setInitialMusic(
      int cPosition,
      dynamic contenttype,
      dynamic dataList,
      String audioId,
      dynamic callApi,
      dynamic isContinueWatching,
      int stoptime,
      String isBuy,
      int isPaid,
      String musicType,
      String artistId) async {
    dynamic songUrl, imageUrl, title;
    printLog("contenttype Value is == $contenttype");
    printLog("contenttype Value is isBuy == $isBuy");
    printLog("contenttype Value is isPaid == $isPaid");
    currentlyPlaying.value = audioPlayer;
    playlist = ConcatenatingAudioSource(children: []);
    episodeDataList = dataList.toList();
    for (int i = 0; i < (episodeDataList?.length ?? 0); i++) {
      if (episodeDataList?[i].music == null &&
          episodeDataList?[i].audio != null) {
        // Case where music is null
        songUrl = episodeDataList?[i].audio.toString() ?? "";
        imageUrl = episodeDataList?[i].image.toString() ?? "";
        title = episodeDataList?[i].name.toString() ?? "";
        printLog(
            "Case 1 - songUrl: $songUrl, imageUrl: $imageUrl, title: $title");
      } else {
        // Case where music is not null
        songUrl = episodeDataList?[i].music.toString() ?? "";
        imageUrl = episodeDataList?[i].portraitImg.toString() ?? "";
        title = episodeDataList?[i].title.toString() ?? "";
        printLog(
            "Case 2 - songUrl: $songUrl, imageUrl: $imageUrl, title: $title");
      }
      await playlist.add(
        buildAudioSource(
            // image: episodeDataList?[i].portraitImg.toString() ?? "",
            image: imageUrl,
            // audioUrl: episodeDataList?[i].music.toString() ?? "",
            audioUrl: songUrl,
            extraDetails: episodeDataList?[i].toMap() ?? {},
            episodeId: episodeDataList?[i].id.toString() ?? "",
            displaydiscription:
                episodeDataList?[i].description.toString() ?? "",
            // title: episodeDataList?[i].title.toString() ?? "",
            title: title,
            contentId: audioId,
            contentType: contenttype,
            isContinueWatching: isContinueWatching,
            musicType: musicType,
            artistID: artistId),
      );
    }

    try {
      log("Enter Try");
      log("playing      :=====================> ${audioPlayer.playing}");
      log("audioSource  :=====================> ${audioPlayer.audioSource?.sequence.length}");
      log("playlist     :=====================> ${playlist.length}");
      // Preloading audio is not currently supported on Linux.
      await audioPlayer.setAudioSource(playlist, initialIndex: cPosition);
      // if (isContinueWatching == true) {
      log("History Play");
      seek(Duration(milliseconds: stoptime));
      play();
      // } else {
      //   log("Simple Play");
      //   play();
      // }

      callApi();
    } catch (e) {
      log("Error loading audio source: $e");
    }
  }

// /* Music */
//   void setDownloadInitialMusic(
//       int cPosition,
//       dynamic contenttype,
//       dynamic dataList,
//       String audioId,
//       dynamic callApi,
//       dynamic isContinueWatching,
//       int stoptime,
//       String isBuy,
//       int isPaid,
//       String musicType,
//       String artistId) async {
//     dynamic songUrl, imageUrl, title;
//     dynamic tempFile;

//     currentlyPlaying.value = audioPlayer;
//     playlist = ConcatenatingAudioSource(children: []);
//     episodeDataList = dataList.toList();

//     /* Decrypt & Play START ******************** */
//     tempFile = await Utils.decryptUsingFFMPEG([
//       File(episodeDataList?[cPosition].savedFile.toString() ?? ""),
//       episodeDataList?[cPosition].securityKey ?? "",
//       episodeDataList?[cPosition].securityKey ?? "",
//       context,
//     ]);

//     if (tempFile != null) {
//       printLog("tempFile ===isolate===> $tempFile");

//       songUrl = tempFile;
//       imageUrl = episodeDataList?[cPosition].image.toString() ?? "";
//       title = episodeDataList?[cPosition].name.toString() ?? "";
//       printLog(
//           "Case 1 - songUrl: $songUrl, imageUrl: $imageUrl, title: $title");

//       printLog("songUrl ==== ${tempFile?.path}");

//       await playlist.add(
//         buildAudioFile(
//             image: imageUrl ?? "",
//             audioUrl: tempFile?.path ?? "",
//             extraDetails: episodeDataList?[cPosition].toMap() ?? {},
//             episodeId: episodeDataList?[cPosition].id.toString() ?? "",
//             displaydiscription:
//                 episodeDataList?[cPosition].description.toString() ?? "",
//             title: title ?? "",
//             contentId: audioId,
//             contentType: contenttype ?? "",
//             isContinueWatching: isContinueWatching ?? "",
//             musicType: musicType,
//             artistID: artistId),
//       );

//       try {
//         log("Enter Try");
//         log("playing      :=====================> ${audioPlayer.playing}");
//         log("audioSource  :=====================> ${audioPlayer.audioSource?.sequence.length}");
//         log("playlist     :=====================> ${playlist.length}");
//         // Preloading audio is not currently supported on Linux.
//         await audioPlayer.setAudioSource(playlist, initialIndex: cPosition);
//         // if (isContinueWatching == true) {
//         log("History Play");
//         seek(Duration(milliseconds: stoptime));
//         play();
//         // } else {
//         //   log("Simple Play");
//         //   play();
//         // }

//         callApi();
//       } catch (e) {
//         log("Error loading audio source: $e");
//       }
//     }
//   }

  void setDownloadInitialMusic(
      int cPosition,
      dynamic contenttype,
      dynamic dataList,
      String audioId,
      dynamic callApi,
      dynamic isContinueWatching,
      int stoptime,
      String isBuy,
      int isPaid,
      String musicType,
      String artistId,
      Function callback) async {
    final downloadProvider =
        Provider.of<DownLoadProvider>(context, listen: false);
    await downloadProvider.setDecryptLoading(true);

    // Utils().showProgressNew(context);
    dynamic songUrl, imageUrl, title;
    printLog("contenttype Value is == $contenttype");
    printLog("contenttype Value is isBuy == $isBuy");
    printLog("contenttype Value is isPaid == $isPaid");
    currentlyPlaying.value = audioPlayer;
    playlist = ConcatenatingAudioSource(children: []);
    episodeDataList = dataList.toList();

    for (int i = 0; i < (episodeDataList?.length ?? 0); i++) {
      dynamic tempFile = await Utils.decryptUsingFFMPEG(context, [
        File(episodeDataList?[i].savedFile.toString() ?? ""),
        episodeDataList?[i].securityKey ?? "",
        episodeDataList?[i].securityKey ?? "",
        context,
      ]);

      if (tempFile != null) {
        printLog("tempFile ===isolate===> $tempFile");

        songUrl = tempFile;
        imageUrl = episodeDataList?[i].image.toString() ?? "";
        title = episodeDataList?[i].name.toString() ?? "";
        printLog(
            "Case 1 - songUrl: $songUrl, imageUrl: $imageUrl, title: $title");

        printLog("songUrl ==== ${tempFile?.path}");

        await playlist.add(
          buildAudioFile(
              image: imageUrl ?? "",
              audioUrl: tempFile?.path ?? "",
              extraDetails: episodeDataList?[i].toMap() ?? {},
              episodeId: episodeDataList?[i].id.toString() ?? "",
              displayDescription:
                  episodeDataList?[i].description.toString() ?? "",
              title: title ?? "",
              contentId: audioId,
              contentType: "download",
              isContinueWatching: isContinueWatching ?? "",
              musicType: musicType,
              artistID: artistId),
        );
      }
    }

    await callback();
    await downloadProvider.setDecryptLoading(false);

    try {
      log("Enter Try");
      log("playing      :=====================> ${audioPlayer.playing}");
      log("audioSource  :=====================> ${audioPlayer.audioSource?.sequence.length}");
      log("playlist     :=====================> ${playlist.length}");
      // Preloading audio is not currently supported on Linux.
      await audioPlayer.setAudioSource(playlist, initialIndex: cPosition);
      // if (isContinueWatching == true) {
      log("History Play");
      seek(Duration(milliseconds: stoptime));
      play();
      // } else {
      //   log("Simple Play");
      //   play();
      // }

      callApi();
    } catch (e) {
      log("Error loading audio source: $e");
    }
  }

  void play() async {
    audioPlayer.play();
  }

  void pause() {
    audioPlayer.pause();
  }

  void seek(Duration position) {
    audioPlayer.seek(position);
  }

  void dispose() {
    audioPlayer.dispose();
  }

  clearMusicPlayer() async {
    episodeDataList = [];
    playlist = ConcatenatingAudioSource(children: []);
    for (var i = 0; i < playlist.length; i++) {
      playlist.removeAt(i);
    }
    playlist.clear();
  }
}
